#include <proc.h>
#include <sched.h>
#include <mittos/graphics.h>
#include <memory.h>

extern gfx_context *term_fb;
extern gfx_context kernel_fb;

int *position = (void *)0x20000;

void thread1()
{
    int a = 1;
    gfx_context *ctx = framebuffer_make_subcontext(&kernel_fb, 700, 300, 100, 100);
    while(1) {
        putCharacter(term_fb, *position, *position, RGB(255,255,0), RGB(0,0,0), '0'+(a++%10));
        flip(term_fb);
        draw_line(ctx, 0, 100, 50, ((a-1)%100), RGB(0,0,0));
        draw_line(ctx, 0, 100, 50, (a%100), RGB(255,0,0));
        flip(ctx);

        sched_yield();
    }
}

void thread2()
{
    int a = 0;
    while(1) {
        putCharacter(term_fb, *position, *position, RGB(0,255,255), RGB(0,0,0), 'A'+(a++%10));
        flip(term_fb);
        sched_yield();
        
    }
}


void TEMP_test_scheduler()
{
    struct process *th1 = new_process(thread1);
    scheduler_insert(th1);

    struct process *th2 = new_process(thread2);
    scheduler_insert(th2);

    uint64_t p1 = pmm_alloc();
    uint64_t p2 = pmm_alloc();
    vmm_set_page(th1->P4, 0x20000, p1, PAGE_PRESENT);
    vmm_set_page(th2->P4, 0x20000, p2, PAGE_PRESENT);
    // Write different values into the position variable for the two processes
    int *a = P2V(p1);
    *a = 20;
    a = P2V(p2);
    *a = 70;
}